<?php
/**
 * Carpets and Rugs functions and definitions
 *
 * @package Carpets and Rugs
 */

if ( ! defined( 'CARPETS_AND_RUGS_VERSION' ) ) {
	// Replace the version number of the theme on each release.
	define( 'CARPETS_AND_RUGS_VERSION', '1.0.0' );
}

function carpets_and_rugs_setup() {

	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'title-tag' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'woocommerce' );
	add_theme_support( "align-wide" );
	add_theme_support( "responsive-embeds" );

	register_nav_menus(
		array(
			'menu-1' => esc_html__( 'Primary', 'carpets-and-rugs' ),
			'social-menu' => esc_html__('Social Menu', 'carpets-and-rugs'),
		)
	);

	add_theme_support(
		'html5',
		array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
			'style',
			'script',
		)
	);

	add_theme_support(
		'custom-background',
		apply_filters(
			'carpets_and_rugs_custom_background_args',
			array(
				'default-color' => '#fafafa',
				'default-image' => '',
			)
		)
	);

	add_theme_support( 'customize-selective-refresh-widgets' );

	add_theme_support(
		'custom-logo',
		array(
			'height'      => 250,
			'width'       => 250,
			'flex-width'  => true,
			'flex-height' => true,
		)
	);

	add_theme_support( 'post-formats', array(
        'image',
        'video',
        'gallery',
        'audio', 
    ));
	
}
add_action( 'after_setup_theme', 'carpets_and_rugs_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $carpets_and_rugs_content_width
 */
function carpets_and_rugs_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'carpets_and_rugs_content_width', 640 );
}
add_action( 'after_setup_theme', 'carpets_and_rugs_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function carpets_and_rugs_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'carpets-and-rugs' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'carpets-and-rugs' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 1', 'carpets-and-rugs' ),
			'id'            => 'footer-1',
			'description'   => esc_html__( 'Add widgets here.', 'carpets-and-rugs' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 2', 'carpets-and-rugs' ),
			'id'            => 'footer-2',
			'description'   => esc_html__( 'Add widgets here.', 'carpets-and-rugs' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 3', 'carpets-and-rugs' ),
			'id'            => 'footer-3',
			'description'   => esc_html__( 'Add widgets here.', 'carpets-and-rugs' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
}
add_action( 'widgets_init', 'carpets_and_rugs_widgets_init' );


function carpets_and_rugs_social_menu()
    {
        if (has_nav_menu('social-menu')) :
            wp_nav_menu(array(
                'theme_location' => 'social-menu',
                'container' => 'ul',
                'menu_class' => 'social-menu menu',
                'menu_id'  => 'menu-social',
            ));
        endif;
    }


/**
 * Enqueue scripts and styles.
 */

function carpets_and_rugs_scripts() {
    // Google Fonts
    $query_args = array(
        'family' => rawurlencode('Caveat Brush|Montserrat:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900'),
        'display' => 'swap',
    );
    wp_enqueue_style('carpets-and-rugs-google-fonts', add_query_arg($query_args, 'https://fonts.googleapis.com/css'), array(), null);

    // Font Awesome CSS
    wp_enqueue_style('font-awesome-6', get_template_directory_uri() . '/revolution/assets/vendors/font-awesome-6/css/all.min.css', array(), '6.7.2');

    // Owl Carousel CSS
    wp_enqueue_style('owl-carousel-style', get_template_directory_uri() . '/revolution/assets/css/owl.carousel.css', array(), wp_get_theme()->get('Version'));

    // Main stylesheet
    wp_enqueue_style('carpets-and-rugs-style', get_stylesheet_uri(), array(), wp_get_theme()->get('Version'));

    // Check if custom styles exist before adding inline styles
    if (file_exists(get_parent_theme_file_path('/custom-style.php'))) {
        require get_parent_theme_file_path('/custom-style.php');

        if (!empty($carpets_and_rugs_custom_css)) {
            wp_add_inline_style('carpets-and-rugs-style', $carpets_and_rugs_custom_css);
        }
    }

    // RTL styles if needed
    if (file_exists(get_stylesheet_directory() . '/rtl.css')) {
        wp_style_add_data('carpets-and-rugs-style', 'rtl', 'replace');
    }

    // Navigation script
    wp_enqueue_script('carpets-and-rugs-navigation', get_template_directory_uri() . '/js/navigation.js', array(), wp_get_theme()->get('Version'), true);

    // Owl Carousel script
    wp_enqueue_script('owl-carousel-jquery', get_template_directory_uri() . '/revolution/assets/js/owl.carousel.js', array('jquery'), wp_get_theme()->get('Version'), true);

    // Wow script.
	wp_enqueue_script( 'wow-jquery', get_template_directory_uri() . '/revolution/assets/js/wow.js', array('jquery'),'' ,true );
	// Animate CSS
	wp_enqueue_style( 'animate-style', get_template_directory_uri() . '/revolution/assets/css/animate.css' );

    // Custom script
    wp_enqueue_script('carpets-and-rugs-custom-js', get_template_directory_uri() . '/revolution/assets/js/custom.js', array('jquery'), wp_get_theme()->get('Version'), true);

    // Comments reply script
    if (is_singular() && comments_open() && get_option('thread_comments')) {
        wp_enqueue_script('comment-reply');
    }
}
add_action('wp_enqueue_scripts', 'carpets_and_rugs_scripts');

if (!function_exists('carpets_and_rugs_related_post')) :
    /**
     * Display related posts from same category
     *
     */

    function carpets_and_rugs_related_post($post_id){        
        $carpets_and_rugs_categories = get_the_category($post_id);
        if ($carpets_and_rugs_categories) {
            $carpets_and_rugs_category_ids = array();
            $carpets_and_rugs_category = get_category($carpets_and_rugs_category_ids);
            $carpets_and_rugs_categories = get_the_category($post_id);
            foreach ($carpets_and_rugs_categories as $carpets_and_rugs_category) {
                $carpets_and_rugs_category_ids[] = $carpets_and_rugs_category->term_id;
            }
            $carpets_and_rugs_count = $carpets_and_rugs_category->category_count;
            if ($carpets_and_rugs_count > 1) { ?>

         	<?php
		$carpets_and_rugs_related_post_wrap = absint(get_theme_mod('carpets_and_rugs_enable_related_post', 1));
		if($carpets_and_rugs_related_post_wrap == 1){ ?>
                <div class="related-post">
                    
                    <h2 class="post-title"><?php esc_html_e(get_theme_mod('carpets_and_rugs_related_post_text', __('Related Post', 'carpets-and-rugs'))); ?></h2>
                    <?php
                    $carpets_and_rugs_cat_post_args = array(
                        'category__in' => $carpets_and_rugs_category_ids,
                        'post__not_in' => array($post_id),
                        'post_type' => 'post',
                        'posts_per_page' =>  get_theme_mod( 'carpets_and_rugs_related_post_count', '3' ),
                        'post_status' => 'publish',
						'orderby'           => 'rand',
                        'ignore_sticky_posts' => true
                    );
                    $carpets_and_rugs_featured_query = new WP_Query($carpets_and_rugs_cat_post_args);
                    ?>
                    <div class="rel-post-wrap">
                        <?php
                        if ($carpets_and_rugs_featured_query->have_posts()) :

                        while ($carpets_and_rugs_featured_query->have_posts()) : $carpets_and_rugs_featured_query->the_post();
                            ?>
                            <div class="card-item rel-card-item">
								<div class="card-content">
                                    <?php if ( has_post_thumbnail() ) { ?>
                                        <div class="card-media">
                                            <?php carpets_and_rugs_post_thumbnail(); ?>
                                        </div>
                                    <?php } else {
                                        // Fallback default image
                                        $carpets_and_rugs_default_post_thumbnail = get_template_directory_uri() . '/revolution/assets/images/about1.png';
                                        echo '<img class="default-post-img" src="' . esc_url( $carpets_and_rugs_default_post_thumbnail ) . '" alt="' . esc_attr( get_the_title() ) . '">';
                                    } ?>
									<div class="entry-title">
										<h3>
											<a href="<?php the_permalink() ?>">
												<?php the_title(); ?>
											</a>
										</h3>
									</div>
									<div class="entry-meta">
                                        <?php
                                        carpets_and_rugs_posted_on();
                                        carpets_and_rugs_posted_by();
                                        ?>
                                    </div>
								</div>
							</div>
                        <?php
                        endwhile;
                        ?>
                <?php
                endif;
                wp_reset_postdata();
                ?>
                </div>
                <?php } ?>
                <?php
            }
        }
    }
endif;
add_action('carpets_and_rugs_related_posts', 'carpets_and_rugs_related_post', 10, 1);

/**
 * Checkbox sanitization callback example.
 *
 * Sanitization callback for 'checkbox' type controls. This callback sanitizes `$carpets_and_rugs_checked`
 * as a boolean value, either TRUE or FALSE.
 */
function carpets_and_rugs_sanitize_checkbox($carpets_and_rugs_checked)
{
    // Boolean check.
    return ((isset($carpets_and_rugs_checked) && true == $carpets_and_rugs_checked) ? true : false);
}

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/revolution/inc/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/revolution/inc/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/revolution/inc/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/revolution/inc/customizer.php';

/**
 * Breadcrumb File.
 */
require get_template_directory() . '/revolution/inc/breadcrumbs.php';

/**
 * Custom typography options for this theme.
 */
require get_template_directory() . '/revolution/inc/typography-options.php';

//////////////////////////////////////////////   Function for Translation Error   //////////////////////////////////////////////////////
function carpets_and_rugs_enqueue_function() {

    /**
    * GET START.
    */
    require get_template_directory() . '/getstarted/carpets_and_rugs_about_page.php';

    /**
    * DEMO IMPORT.
    */
    require get_template_directory() . '/demo-import/carpets_and_rugs_config_file.php';

    define('CARPETS_AND_RUGS_FREE_SUPPORT',__('https://wordpress.org/support/theme/carpets-and-rugs/','carpets-and-rugs'));
    define('CARPETS_AND_RUGS_PRO_SUPPORT',__('https://www.revolutionwp.com/pages/community/','carpets-and-rugs'));
    define('CARPETS_AND_RUGS_REVIEW',__('https://wordpress.org/support/theme/carpets-and-rugs/reviews/#new-post','carpets-and-rugs'));
    define('CARPETS_AND_RUGS_BUY_NOW',__('https://www.revolutionwp.com/products/carpets-wordpress-theme','carpets-and-rugs'));
    define('CARPETS_AND_RUGS_LIVE_DEMO',__('https://demo.revolutionwp.com/carpets-and-rugs-pro/','carpets-and-rugs'));
    define('CARPETS_AND_RUGS_PRO_DOC',__('https://demo.revolutionwp.com/wpdocs/carpets-and-rugs-pro/','carpets-and-rugs'));
    define('CARPETS_AND_RUGS_LITE_DOC',__('https://demo.revolutionwp.com/wpdocs/carpets-and-rugs-free/','carpets-and-rugs'));
}
add_action( 'after_setup_theme', 'carpets_and_rugs_enqueue_function' );


/**
 * Load Jetpack compatibility file.
 */
if ( defined( 'JETPACK__VERSION' ) ) {
	require get_template_directory() . '/revolution/inc/jetpack.php';

}

function carpets_and_rugs_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'carpets_and_rugs_remove_customize_register', 11 );

/************************************************************************************/

/**
 * WooCommerce custom filters
 */
add_filter('loop_shop_columns', 'carpets_and_rugs_loop_columns');

if (!function_exists('carpets_and_rugs_loop_columns')) {

	function carpets_and_rugs_loop_columns() {

		$carpets_and_rugs_columns = get_theme_mod( 'carpets_and_rugs_per_columns', 3 );

		return $carpets_and_rugs_columns;
	}
}

/************************************************************************************/

add_filter( 'loop_shop_per_page', 'carpets_and_rugs_per_page', 20 );

function carpets_and_rugs_per_page( $carpets_and_rugs_cols ) {

  	$carpets_and_rugs_cols = get_theme_mod( 'carpets_and_rugs_product_per_page', 9 );

	return $carpets_and_rugs_cols;
}

/************************************************************************************/

add_filter( 'woocommerce_output_related_products_args', 'carpets_and_rugs_products_args' );

function carpets_and_rugs_products_args( $carpets_and_rugs_args ) {

    $carpets_and_rugs_args['posts_per_page'] = get_theme_mod( 'custom_related_products_number', 6 );

    $carpets_and_rugs_args['columns'] = get_theme_mod( 'custom_related_products_number_per_row', 3 );

    return $carpets_and_rugs_args;
}

/************************************************************************************/


/**
 * Custom logo
 */

function carpets_and_rugs_custom_css() {
?>
	<style type="text/css" id="custom-theme-colors" >
        :root {
           
            --carpets_and_rugs_logo_width: <?php echo absint(get_theme_mod('carpets_and_rugs_logo_width')); ?> ;   
        }
        .site-branding img {
            max-width:<?php echo esc_html(get_theme_mod('carpets_and_rugs_logo_width')); ?>px ;    
        }         
	</style>
<?php
}
add_action( 'wp_head', 'carpets_and_rugs_custom_css' );

function carpets_and_rugs_sanitize_choices( $carpets_and_rugs_input, $carpets_and_rugs_setting ) {
    global $wp_customize; 
    $carpets_and_rugs_control = $wp_customize->get_control( $carpets_and_rugs_setting->id ); 
    if ( array_key_exists( $carpets_and_rugs_input, $carpets_and_rugs_control->choices ) ) {
        return $carpets_and_rugs_input;
    } else {
        return $carpets_and_rugs_setting->default;
    }
}

//Excerpt 
function carpets_and_rugs_excerpt_function($carpets_and_rugs_excerpt_count = 35) {
    $carpets_and_rugs_excerpt = get_the_excerpt();
    $carpets_and_rugs_text_excerpt = wp_strip_all_tags($carpets_and_rugs_excerpt);
    $carpets_and_rugs_excerpt_limit = (int) get_theme_mod('carpets_and_rugs_excerpt_limit', $carpets_and_rugs_excerpt_count);
    $carpets_and_rugs_words = preg_split('/\s+/', $carpets_and_rugs_text_excerpt); 
    $carpets_and_rugs_trimmed_words = array_slice($carpets_and_rugs_words, 0, $carpets_and_rugs_excerpt_limit);
    $carpets_and_rugs_theme_excerpt = implode(' ', $carpets_and_rugs_trimmed_words);

    return $carpets_and_rugs_theme_excerpt;
}

function carpets_and_rugs_sanitize_dropdown_pages( $carpets_and_rugs_page_id, $carpets_and_rugs_setting ) {
  // Ensure $carpets_and_rugs_input is an absolute integer.
  $carpets_and_rugs_page_id = absint( $carpets_and_rugs_page_id );
  // If $carpets_and_rugs_page_id is an ID of a published page, return it; otherwise, return the default.
  return ( 'publish' == get_post_status( $carpets_and_rugs_page_id ) ? $carpets_and_rugs_page_id : $carpets_and_rugs_setting->default );
}

// Add admin notice
function carpets_and_rugs_admin_notice() { 
    global $pagenow;
    $carpets_and_rugs_theme_args      = wp_get_theme();
    $carpets_and_rugs_meta            = get_option( 'carpets_and_rugs_admin_notice' );
    $name            = $carpets_and_rugs_theme_args->__get( 'Name' );
    $carpets_and_rugs_current_screen  = get_current_screen();

    if( !$carpets_and_rugs_meta ){
	    if( is_network_admin() ){
	        return;
	    }

	    if( ! current_user_can( 'manage_options' ) ){
	        return;
	    } 
		
		if( $carpets_and_rugs_current_screen->base !== 'appearance_page_carpets_and_rugs_guide' && 
            $carpets_and_rugs_current_screen->base !== 'toplevel_page_carpetsandrugs-demoimport' ) { ?>

            <div class="notice notice-success carpets-and-rugs-welcome-notice">
                <p class="carpets-and-rugs-dismiss-link">
                    <strong>
                        <a href="<?php echo esc_url( add_query_arg( 'carpets_and_rugs_admin_notice', '1' ) ); ?>">
                            <?php esc_html_e( 'Dismiss', 'carpets-and-rugs' ); ?>
                        </a>
                    </strong>
                </p>

                <div class="carpets-and-rugs-welcome-notice-wrap">
                    <h2 class="carpets-and-rugs-notice-title">
                        <span class="dashicons dashicons-admin-home"></span> 
                        <?php 
                            $carpets_and_rugs_theme_name = wp_get_theme()->get( 'Name' );
                            /* translators: %s!: Theme Name. */
                            echo esc_html( sprintf( __( 'Welcome to the free theme: %s!', 'carpets-and-rugs' ), $carpets_and_rugs_theme_name ) );
                        ?>
                    </h2>
                    <p class="carpets-and-rugs-notice-desc">
                        <?php esc_html_e( 'Get started by exploring the features of your new theme. Customize your design, add your content, and create a site that fits your vision.', 'carpets-and-rugs' ); ?>
                    </p>

                    <div class="carpets-and-rugs-welcome-info">
                        <div class="carpets-and-rugs-welcome-thumb">
                            <img src="<?php echo esc_url( get_stylesheet_directory_uri() . '/screenshot.png' ); ?>" alt="<?php esc_attr_e( 'Theme Screenshot', 'carpets-and-rugs' ); ?>">
                        </div>

                        <div class="carpets-and-rugs-welcome-import">
                            <h3><span class="dashicons dashicons-download"></span> <?php esc_html_e( 'Quick Start: Import Demo', 'carpets-and-rugs' ); ?></h3>
                            <p><?php esc_html_e( 'Use the Demo Importer to quickly set up your site with a pre-made layout. Get a complete site in minutes.', 'carpets-and-rugs' ); ?></p>
                            <p><a class="button info-link button-primary" href="<?php echo esc_url( admin_url( 'themes.php?page=carpetsandrugs-demoimport' ) ); ?>"><?php esc_html_e( 'Go to Demo Importer', 'carpets-and-rugs' ); ?></a></p>
                        </div>

                        <div class="carpets-and-rugs-welcome-getting-started">
                            <h3><span class="dashicons dashicons-art"></span> <?php esc_html_e( 'Customize Your Theme', 'carpets-and-rugs' ); ?></h3>
                            <p><?php esc_html_e( 'Want to make it truly yours? Explore the Getting Started Guide to personalize your site to suit your needs.', 'carpets-and-rugs' ); ?></p>
                            <p><a class="info-link button" href="<?php echo esc_url( admin_url( 'themes.php?page=carpets-and-rugs-getstart-page' ) ); ?>"><?php esc_html_e( 'View Getting Started Guide', 'carpets-and-rugs' ); ?></a></p>
                        </div>
                    </div>
                </div>
            </div>

            <?php
        }

	}
}

add_action( 'admin_notices', 'carpets_and_rugs_admin_notice' );

if( ! function_exists( 'carpets_and_rugs_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
*/
function carpets_and_rugs_update_admin_notice(){
    if ( isset( $_GET['carpets_and_rugs_admin_notice'] ) && $_GET['carpets_and_rugs_admin_notice'] = '1' ) {
        update_option( 'carpets_and_rugs_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'carpets_and_rugs_update_admin_notice' );


add_action('after_switch_theme', 'carpets_and_rugs_setup_options');
function carpets_and_rugs_setup_options () {
    update_option('carpets_and_rugs_admin_notice', FALSE );
}

// changelog
function get_changelog_from_readme() {
    $carpets_and_rugs_file_path = get_template_directory() . '/readme.txt'; // Adjust path if necessary

    if (file_exists($carpets_and_rugs_file_path)) {
        $carpets_and_rugs_content = file_get_contents($carpets_and_rugs_file_path);

        // Extract changelog section
        $carpets_and_rugs_changelog_start = strpos($carpets_and_rugs_content, "== Changelog ==");
        $carpets_and_rugs_changelog = substr($carpets_and_rugs_content, $carpets_and_rugs_changelog_start);

        // Split changelog into versions
        preg_match_all('/\*\s([\d\.]+)\s-\s(.+?)\n((?:\t-\s.+?\n)+)/', $carpets_and_rugs_changelog, $carpets_and_rugs_matches, PREG_SET_ORDER);
        
        return $carpets_and_rugs_matches;
    }
    return [];
}

add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );